# Prekladatelj ![* Interslavic flag *](http://steen.free.fr/interslavic/slovianski.ico)
[Read in English](README.md) // [Читати в Меджусловjанском jезыку](README_isl_cy.md)

CLI програма и гем Ruby (библиотека) длја транслитерацији текстов в [Меджусловјанском](http://steen.free.fr/interslavic/index.html) језыку с Латинице на Кирилицу и обратно.
Так (како програма):

```shell
prekladatelj -c --eastern file1.txt file2.html file3
```

или так (како библиотека):

```ruby
"Меджусловјанскы јест језык, кторы Словјани разных народностиј користајут".to_latin
#=> "Medžuslovjansky jest jezyk, ktory Slovjani raznyh narodnostij koristajut"
"Jabloko sut jedlivy plod".to_cyrillic
#=> "Јаблоко сут једливы плод"
```
То јест добро длја веб-сајтов на Rails или програм на Ruby, користајучим Меджусловјанскы језык.
Можно подавати тексты на обојих писмах (вклјучајучи [Флаворизацију](#Флаворизација)) без ручного прекладу.

## Поставјенје

    $ gem install prekladatelj
(потрєбно ``rubygems``)

Ако ли једино библиотека потрєбна, пиши сеју линију в Gemfile твојеј апликацији (ако користајеш оныј):

```ruby
gem 'prekladatelj'
```

Потом изполни:

    $ bundle install

(ако ли ты знајеш, како јест творимы гемы, клонируј сеј репозиториј и изполни ``rake install``)
## Користанје

### Како програма
Од версији 0.1.2 _Prekladatelj_ имаје интерфејс редка наказа (командној линији, CLI):
```shell
prekladatelj -c --eastern file1.txt file2.html file3
```
Сеј интерфејс буде доступны послє поставјенја с наказом ``gem install``

Изполни с опцијеју ``-c`` или ``-l`` (то значи прєкладати до кирили``ц``и или ``л``атиници), такоже јест можно давати флаворизацију,
наприклад ``--eastern``, послє пиши назвы фајлов, кторы јест потрєбно транслитеровати до сего алфабета.
Избор фајлов како в *nix јест доступны, тому ``*`` значит "все фајлы в сеј папке/директорији", ``*_isv.html`` јест "все фајлы, кторы кончајут се с _isv.html" и тако далје.
Прекладателј читаје фајлы ``.txt``, ``.html`` или без суфикса/разширјенја, другы фајлы игнорује, једнако јест можно насилно транслитероавти јих с опцијеју ``--force``.

Изполни ``prekladatelj`` без опциј, да бы видєти вси доступны опцији.

Прекладателј може творити разумно обработанје HTML фајлов, тому он не обрачаје ``<title>`` в ``<титле>``.
Такоже он не транслитерује контент в тегах CSS класа ``notranslit``, тому можно користати сеј клас длја непреклада нєкторого контента.

Кратко говоречи:
```shell
prekladatelj -c isv.html
```

_isv.html:_
```html
    <title class="notranslit">le website</title>
    <center>
    <h1>Medžuslovjansky v světe internetnoj komunikaciji</h1>
    <small>(myslji ob interslavike)</small>
    </center>
```
_isv_c.html:_
```html
    <title class="notranslit">le website</title>
    <center>
    <h1>Меджусловјанскы в свєте интернетној комуникацији</h1>
    <small>(мыслји об интерславике)</small>
    </center>
```

### Како библиотека

**Prekladatelј** разширјаје ``String``, тому можно користати тако:

```ruby
require 'prekladatelj'
str = "Redok"
str.to_cyrillic #=> "Редок"
# але аж так:
"Богоjaвjeнje".to_latin #=> "Bogojavjenje"
```

Једнако болје тежкиј способ јест можливы (јестли потребно?..):
```ruby
require 'prekladatelj'
Prekladatelj::Cyrillic::to_latin "изjаснити" #=> "izjasniti"
Prekladatelj::Latin::to_cyrillic "Japonija"  #=> "Јапонија"
Prekladatelj::Latin::to_cyrillic "Japonija", :eastern  #=> "Япония"
```
_Prekladatelj_ јест быстры/брзы, але великы тексты рекомендовано записывати в пременноју длја далјшего користанија, јестли
контент не јест динамическы.

Обрати позорност, же оригиналны редок никогды не јест измєнјајемы и потребно писати изход методов в нову пременноју,
да бы схранити транслитерацију. Вот так:

```ruby
cyrillic = some_text.to_cyrillic
```

## Флаворизација

Јестли потребно обратити се к лјудам јединого рода, можно користати [флаворизацију](http://steen.free.fr/interslavic/flavorizacija.html) (Англијскы)
 
**Прекладателј** даваје дефиниовану колекцију сих "запахов", кторы можно предавати методам ``to_xxx``:

```ruby
"Bogojavjenje".to_cyrillic :eastern 
# => "Богоявьенье" 
# standard: "Богоjaвjeнje"
``` 

К часу версији 0.1.2, једины 'флавор' доступны длја ``to_cyrillic`` јест ``:eastern``,
кторы легше читати *Русскым, Украјинцам и Белорусам*.
(буквы **я**, **ю**, **щ**; 'ся' заместо 'се' и тако далје)
```ruby
Prekladatelj::Latin::to_cyrillic "jaščer", :eastern
# => "ящер"
# стандард: "јашчер"
```

## Ограниченја
* В версији 0.1.2, Прекладателју треба, же текст јест писаны по [сејчасному стандарду](http://steen.free.fr/interslavic/orthography.html#standard_alphabet) правопису.
Наприклад, ранеје користана в Кирилице ѣ (како Є) не буде познана (пока). Флаворизованы
тексты такоже пока не можут быти транслитерованы
* ``:eastern`` може быти изкористајуча толико с Латиницеј; длја флаворизацији Кирилицы изпрва преклади јеј до Латиницы (се скоро буде поправјено) 
* ``cz sz zs`` како алтернативы ``č, š, ž`` не јест доступны
* Етимологична абецеда једва когдаколи буде доступна
* Глаголица допока не јест доступна

## Проблемы
Тутој гем јест много млады. Створи issue, ако чтоколи недобро!

## Вкладанје

Прекладателј имаје много можливости длја улепшенија. Ако ты знајеш Ruby, можеш створити форк сего репозиторија и приложити
измены. Pull requests јест привитаны!

Ако знајеш другы језык програмованија, можеш створити ину версију Прекладателја в том језыке, користајучи јего име.
Прошу, уведоми, ако так!